1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147
|
#! /bin/bash
# Creating the build environment with debootstrap.
# pbuilder -- personal Debian package builder
# Copyright (C) 2001-2003,2005-2007 Junichi Uekawa
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
set -e
. /usr/lib/pbuilder/pbuilder-checkparams
. /usr/lib/pbuilder/pbuilder-runhooks
if [ -z "$DISTRIBUTION" ]; then
DISTRIBUTION=sid
fi
log "I: Distribution is $DISTRIBUTION."
if [ "${PBUILDER_DEBUGMODE}" = "yes" ]; then
TRAP="echo ignoring trap "
else
TRAP=trap
fi
# show the current time before doing anything.
echobacktime
# first clean it.
cleanbuildplace
log "I: Building the build environment"
mkdir -p "$BUILDPLACE"
if [ ! -d "$BUILDPLACE" ]; then
log "E: Could not make directory [$BUILDPLACE]"
exit 1
fi
$TRAP cleanbuildplace exit
log "I: running $DEBOOTSTRAP"
unset DEBOOTSTRAPSCRIPT
if [ -n "$HOOKDIR" ]; then
if [ -f "$HOOKDIR/$DISTRIBUTION" ]; then
DEBOOTSTRAPSCRIPT=$(readlink -f "$HOOKDIR")"/$DISTRIBUTION"
log "I: Applying user distribution dist build script $DEBOOTSTRAPSCRIPT"
fi
fi
if which "${DEBOOTSTRAP}"; then
: # debootstrap exists
else
log "E: ${DEBOOTSTRAP} does not exist, install or change DEBOOTSTRAP option"
exit 1
fi
# FIXME if the end-user passes another --include= to debootstrap in
# DEBOOTSTRAPOPTS, it will override the --include=apt one and apt might not be
# installed
if ! ( cd "$BUILDPLACE" && \
"${DEBOOTSTRAP}" ${ARCHITECTURE:+--arch=$ARCHITECTURE} \
--include=apt \
"${DEBOOTSTRAPOPTS[@]}" \
"$DISTRIBUTION" \
. \
"$MIRRORSITE" \
$DEBOOTSTRAPSCRIPT ) ; then
log "E: $DEBOOTSTRAP failed"
exit 1
fi
log "I: debootstrap finished"
loadhooks
mkdir -p "$BUILDPLACE/tmp/buildd"
copy_local_configuration
installaptlines
add_additional_aptkeyrings
executehooks "G"
log "I: Refreshing the base.tgz "
log "I: upgrading packages"
mountproc
$TRAP umountproc_cleanbuildplace_trap exit sighup
$CHROOTEXEC /usr/bin/apt-get -q update
case "`readlink -e "$PBUILDERSATISFYDEPENDSCMD"`" in
*-aptitude)
EXTRAPACKAGES="$EXTRAPACKAGES aptitude"
;;
*)
EXTRAPACKAGES="$EXTRAPACKAGES aptitude-"
;;
esac
if [ -n "$CCACHEDIR" ]; then
EXTRAPACKAGES="$EXTRAPACKAGES ccache"
else
EXTRAPACKAGES="$EXTRAPACKAGES ccache-"
fi
if [ -n "$REMOVEPACKAGES" ]; then
# FIXME this wont work if the packages have some reverse dependencies;
# apt-get can also remove package, either with apt-get remove or purge, or
# with apt-get install name-of-pkg- (i.e. a minus sign after the package
# name)
$CHROOTEXEC /usr/bin/dpkg --purge $REMOVEPACKAGES
fi
recover_aptcache
$CHROOTEXEC /usr/bin/apt-get -q -y "${APTGETOPT[@]}" "${FORCE_CONFNEW[@]}" dist-upgrade
$CHROOTEXEC /usr/bin/apt-get -q -y "${APTGETOPT[@]}" install \
build-essential \
dpkg-dev \
$EXTRAPACKAGES
save_aptcache
executehooks "E"
unloadhooks
umountproc
$CHROOTEXEC /usr/bin/apt-get clean || true
$TRAP cleanbuildplace_trap exit sighup
# Internal_build_uml is set when --no-targz is set, this code is actually never called from pbuilder-user-mode-linux
if [ ! "${INTERNAL_BUILD_UML}" = "yes" ]; then
create_basetgz
fi
if [ "${PRESERVE_BUILDPLACE}" = "yes" ]; then
:
else
:
cleanbuildplace
fi
trap - exit sighup
exit 0
|